<?php

  class sml_data_sources extends sml_data
  {

    # ----------------------------------------------------------------------------------------
    #                                                                         status de source
    #

    function source_status()
    { $sgbd = $this->sgbd();
      $env = $this->env();
      $status = array();
      if($rst = $sgbd->open_data("source_status"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { $status[$v_rst["id"]] = $v_rst;
          }
          else
          { $status = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $status = false;
      return $status;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                  compositions de sources
    #

    function source_compositions($params)
    { $id_source = isset($params["id_source"]) ? $params["id_source"] : null;  
      $id_composition = isset($params["id_composition"]) ? $params["id_composition"] : null;
      $index = isset($params["index"]) ? $params["index"] : "id_composition";
      if($index != "id_composition" && $index != "id_source") return false;
      $sgbd = $this->sgbd();
      $env = $this->env();
      $compositions = array();
      if($rst = $sgbd->open_data("source_compositions"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { if(isset($v_rst["id_source"]) && isset($v_rst["id_composition"]))
            { if(isset($id_source))
              { if($v_rst["id_source"] == $id_source)
                { if(!isset($compositions[$v_rst["id_source"]])) $compositions[$v_rst["id_source"]] = array();
                  $compositions[$v_rst["id_source"]][] = $v_rst["id_composition"];
                }
              }
              elseif(isset($id_composition))
              { if($v_rst["id_composition"] == $id_composition)
                { if(!isset($compositions[$v_rst["id_composition"]])) $compositions[$v_rst["id_composition"]] = array();
                  $compositions[$v_rst["id_composition"]][] = $v_rst["id_source"];
                }
              }
              else
              { if(!isset($compositions[$v_rst["index"]])) $compositions[$v_rst["index"]] = array();
                $compositions[$v_rst["index"]][] = $v_rst[$index == "id_source" ? "id_composition" : "id_source"];
              }
            }
          }
          else
          { $compositions = false;
            break;
          }
        }
        $sgbd->close_data($rst);
      }
      else $compositions = false;
      return $compositions;
    }

    function set_source_composition
    ( $id_source,
      $id_composition
    )
    { $sgbd = $this->sgbd();
      if
      ( $sgbd->add_data
        ( "source_compositions",
          array
          ( "id_source" => $id_source,
            "id_composition" => $id_composition
          )
        )
      ) return $this->set_source_xml($id_composition);
      return false;
    }

    function del_source_compositions($params)
    { $res = true;
      $id_source = isset($params["id_source"]) ? $params["id_source"] : null;  
      $id_composition = isset($params["id_composition"]) ? $params["id_composition"] : null;
      $to_delete = array();
      $to_update = array();
      if(isset($id_composition)) $to_update[] = $id_composition;
      $sgbd = $this->sgbd();
      if($rst = $sgbd->open_data("source_compositions"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst))
          { if(isset($v_rst["id_source"]) && isset($v_rst["id_composition"]))
            { if(isset($id_source))
              { if($v_rst["id_source"] == $id_source)
                { $to_delete[] = $v_rst["id"];
                  $to_update[] = $v_rst["id_composition"];
                }
              }
              elseif(isset($id_composition))
              { if($v_rst["id_composition"] == $id_composition)
                { $to_delete[] = $v_rst["id"];
                }
              }
            }
          }
          else
          { $res = false;
            break;
          }
        }
        $sgbd->close_data($rst);
        if($res && $to_delete)
        { foreach($to_delete as $id_source_composition)
          { $res = $sgbd->del_data("source_compositions", $id_source_composition);
            if(!$res) break;
          }
        }
        if($res && $to_update)
        { foreach($to_update as $id_source_xml)
          { $res = $this->set_source_xml($id_source_xml);
            if(!$res) break;
          }
        }
      }
      else $res = false;
      return $res;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                  sources
    #

    function sources($params)
    { // -------------------------------------------------------------------------------
      //                                                                         filtres

      $start = isset($params["start"]) ? $params["start"] : null;
      $id_user = isset($params["id_user"]) ? $params["id_user"] : null;
      $id_groupe = isset($params["id_groupe"]) ? $params["id_groupe"] : null;
      $status = isset($params["status"]) ? $params["status"] : null;
      $id_source = isset($params["id_source"]) ? $params["id_source"] : null;
      $id_composition = isset($params["id_composition"]) ? $params["id_composition"] : null;

      // -------------------------------------------------------------------------------
      //                                                 infos pour verifier les filtres

      $groupes = array();
      if(isset($id_user))
      { if(($groupes = $this->groupes($id_user)) === false)
        { return false;
        }
      }
      $compositions = array();
      if(isset($id_source))
      { if(($compositions = $this->source_compositions(array("id_source" => $id_source))) === false)
        { return false;
        }
      }
      elseif(isset($id_composition))
      { if(($compositions = $this->source_compositions(array("id_composition" => $id_composition))) === false)
        { return false;
        }
      }

      // -------------------------------------------------------------------------------
      //                                                               boucle principale

      $sgbd = $this->sgbd();
      $env = $this->env();
      $sources = array("list" => array(), "total" => 0);
      $res = array();
      if($rst = $sgbd->open_data("sources"))
      { while($v_rst = $sgbd->fetch_data($rst))
        { if(isset($v_rst)) $res[$v_rst["id"]] = $v_rst;
          else
          { $res = false;
            break;
          }
        }
        $sgbd->close_data($rst);
        if($res !== false)
        { $res = $this->ordonne($res, "ordre");
          foreach($res as $id_res => $v_rst)
          {
            $MATCH = true;
            // ------------------------------- filtre sur id_user
            if(isset($id_user))
            { if($groupes["total"] > 0)
              { foreach($groupes["list"] as $_id_groupe => $groupe)
                { if($groupe["id_user"] == $id_user)
                  { $MATCH = true;
                    break;
                  }
                }
              }
              else $MATCH = false;
            }

            // ------------------------------- filtre sur id_groupe
            if($MATCH)
            { $MATCH = !isset($id_groupe) || (isset($v_rst["id_groupe"]) && $v_rst["id_groupe"] == $id_groupe);
            }

            // ------------------------------- filtre sur status
            if($MATCH)
            { $MATCH = !isset($status) || (isset($v_rst["status"]) && $v_rst["status"] == $status);
            }

            // -------------------------------- filtre sur id_source
            if($MATCH)
            { if(isset($id_source))
              { $MATCH = false;
                if($compositions && is_array($compositions[$id_source]))
                { foreach($compositions[$id_source] as $id_composition)
                  { if(isset($v_rst["id"]) && $v_rst["id"] == $id_composition)
                    { $MATCH = true;
                      break;
                    }
                  }
                }
              }
            }

            // -------------------------------- filtre sur id_composition
            if($MATCH)
            { if(isset($id_composition))
              { $MATCH = false;
                if($compositions && is_array($compositions[$id_composition]))
                { foreach($compositions[$id_composition] as $_id_source)
                  { if(isset($v_rst["id"]) && $v_rst["id"] == $_id_source)
                    { $MATCH = true;
                      break;
                    }
                  }
                }
              }
            }

            // -------------------------------- filtre sur quantite de resultats
            if($MATCH)
            { $sources["total"]++;
              $MATCH = !isset($start) || !$env->config("max_list") || ($sources["total"] > $start && $sources["total"] <= ($start + $env->config("max_list")));
            }

            // -------------------------------- ajout aux resultats si MATCH
            if($MATCH) $sources["list"][$v_rst["id"]] = $v_rst;
          }
          
        }
      }
      else return false;
      foreach($sources["list"] as $id_source => $source)
      { if(($sources["list"][$id_source] = $this->load_source($sources["list"][$id_source])) === false) return false;
      }
      return $sources;
    }

    function source($id)
    { $sgbd = $this->sgbd();
      if(($source = $sgbd->get_data("sources", $id)) !== false)
      { if(($source = $this->load_source($source)) !== false)
        { return $source;
        }
      }
      return false;
    }

    function load_source($source)
    { if(isset($source["id"]))
      { if($source["reference"])
        { if(($source["reference_content"] = $this->source_xml_read($source["reference"])) === false)
          { $source["reference_content"] = $this->empty_source();
          }
          return $source;
        }
        else
        { if(($source["documents"] = $this->source_documents($source["id"])) !== false)
          { if(($groupe = $this->groupe($source["id_groupe"])) !== false)
            { $source["id_user"] = $groupe["id_user"];
              return $source;
            }
          }
        }
      }
      return false;
    }

    function empty_source()
    { return array
      ( "auteur" => "",
        "titre" => "",
        "from" => "",
        "licence" => array(),
        "documents" => array()
      );
    }

    function source_documents($id_source)
    { $sgbd = $this->sgbd();
      $documents = array();
      if($rst = $sgbd->open_data("sources/".$id_source))
      { $OK = true;
        while($OK && ($document = $sgbd->fetch_data($rst)))
        { if(isset($document)) $documents[$document["id"]] = $document;
          else $OK = false;
        }
        $sgbd->close_data($rst);
      }
      else $OK = false;
      if(!$OK) return false;
      return $documents;
    }

    function add_source
    ( $id_groupe,
      $nom,
      $documents = array(),
      $licence,
      $reference,
      $status,
      $infos = array()
    )
    { $sgbd = $this->sgbd();
      if($reference)
      { $source = array
        ( "id_groupe" => $id_groupe,
          "reference" => $reference,
          "status" => $status
        );
      }
      else
      { $source = array
        ( "id_groupe" => $id_groupe,
          "nom" => $nom,
          "licence" => $licence,
          "status" => $status
        );
      }
      foreach($infos as $key => $value) if(!isset($source[$key])) $source[$key] = $value;
      $res = $sgbd->add_data("sources", $source);
      if(!isset($res)) return false;
      else
      { if($sgbd->create_data("sources/".$res))
        { if(!$reference) foreach($documents as $_document)
          { $document = array
            ( "nom" => $_document["nom"],
              "url" => $_document["url"]
            );
            if(!$sgbd->add_data("sources/".$res, $document)) return false;
          }
        }
        else return false;
        if(!$this->set_source_xml($res)) return false;
      }
      return $res;
    }

    function set_source
    ( $id,
      $id_groupe,
      $nom,
      $documents = array(),
      $licence,
      $reference,
      $status,
      $infos = array()
    )
    { if(($source = $this->source($id)) !== false)
      { $sgbd = $this->sgbd();
        if($reference)
        { $source = array
          ( "id_groupe" => $id_groupe,
            "reference" => $reference,
            "status" => $status
          );
        }
        else
        { $source = array
          ( "id_groupe" => $id_groupe,
            "nom" => $nom,
            "licence" => $licence,
            "status" => $status
          );
        }
        foreach($infos as $key => $value) if(!isset($source[$key])) $source[$key] = $value;
        if($sgbd->remove_data("sources/".$id) && $sgbd->create_data("sources/".$id))
        { if(!$reference) foreach($documents as $_document)
          { $document = array
            ( "nom" => $_document["nom"],
              "url" => $_document["url"]
            );
            if(!$sgbd->add_data("sources/".$id, $document)) return false;
          }
        }
        else return false;
        return $sgbd->set_data("sources", $id, $source) && $this->set_source_xml($id);
      }
      return false;
    }

    function del_source($id)
    { $sgbd = $this->sgbd();
      if($sgbd->remove_data("sources/".$id))
      { if($sgbd->del_data("sources", $id))
        { if($rst = $sgbd->open_data("source_compositions"))
          { while($v_rst = $sgbd->fetch_data($rst))
            { if(isset($v_rst) && isset($v_rst["id_source"]) && isset($v_rst["id_composition"]))
              { $COMPOSITION_DELETED = false;
                if($v_rst["id_source"] == $id)
                { if
                  (    !$sgbd->del_data("source_compositions", $v_rst["id"])
                    || !$this->set_source_xml($v_rst["id_composition"])
                  ) return false;
                  $COMPOSITION_DELETED = true;
                }
                if(!$COMPOSITION_DELETED && $v_rst["id_composition"] == $id)
                { if(!$sgbd->del_data("source_compositions", $v_rst["id"])) return false;
                }
              }
              else
              { $sgbd->close_data($rst);
                return false;
              }
            }
            $sgbd->close_data($rst);
          }
          else return false;
          return $this->del_source_xml($id);
        }
      }
      return false;
    }

  }

?>