<?php

  class sml_env_out extends sml_env
  {
    var $out;
    var $layout;

    function set_out($key, $value) { $this->out[$key] = $value; return $value; }
    function get_out() { return $this->out; }
    function out($key) { return $this->out[$key]; }

    function out_file_exists($file)
    { return
      ( $this->config("out") ?
          file_exists($this->path("out").$this->config("out").$file) ||
          file_exists($this->path("out").$this->path("dist_out").$file)
        : file_exists($this->path("out").$this->path("current_out").$file) ||
          file_exists($this->path("out").$this->path("dist_out").$file)
      );
    }

    function out_file($file)
    { return
      ( $this->config("out") ?
          ( file_exists($this->path("out").$this->config("out").$file) ?
              $this->path("out").$this->config("out").$file
            : (file_exists($this->path("out").$this->path("dist_out").$file) ? $this->path("out").$this->path("dist_out").$file : $file)
          )
        : ( file_exists($this->path("out").$this->path("current_out").$file) ?
              $this->path("out").$this->path("current_out").$file
            : (file_exists($this->path("out").$this->path("dist_out").$file) ? $this->path("out").$this->path("dist_out").$file : $file)
          )
      );
    }

    function out_pathes()
    { $pathes = array();
      if($dh = opendir($this->path("out")))
      { while(($file = readdir($dh)) !== false)
        { if(is_dir($this->path("out").$file) && substr($file, 0 ,1) != ".") $pathes[] = $file;
        }
        closedir($dh);
      }
      else $pathes = false;
      return $pathes;
    }

    function get_empty_layout()
    { return "<"."?xml version=\"1.0\" encoding=\"UTF-8\"?"."><layout><test page=\"test.php\"/></layout>";
    }

    function init_layout()
    { if($this->set_layout($this->get_empty_layout()) !== false)
      { if($this->out_file_exists("layouts/index.xml"))
        { $this->load_layout($this->out_file("layouts/index.xml"));
        }
        if($this->etat("mod") != "index" && $this->out_file_exists("layouts/".$this->etat("mod").".xml"))
        { $this->load_layout($this->out_file("layouts/".$this->etat("mod").".xml"));
        }
      }
      return $this->get_layout();
    }

    function set_layout($layout_content)
    { $xml_parser = new sxml();
      $xml_parser->parse($layout_content);
      $layout = $xml_parser->data;
      $this->layout = $layout; return $this->layout;
    }

    function layout() { return $this->layout; }

    function load_layout($layout_file)
    { if(file_exists($layout_file))
      { $xml_parser = new sxml();
        $xml_parser->parse(file_get_contents($layout_file));
        $layout = $xml_parser->data;
        $this->r_load_layout($layout, $this->layout, "layout");
        return true;
      }
      return false;
    }

    function r_load_layout(&$src, &$dest, $elt_name)
    { if(!isset($dest[$elt_name])) $dest[$elt_name] = array(0 => array());
      if(isset($src[$elt_name][0]["attrs"]["page"]))
      { if(!isset($dest[$elt_name][0]["attrs"])) $dest[$elt_name][0]["attrs"] = array();
        $dest[$elt_name][0]["attrs"]["page"] = $src[$elt_name][0]["attrs"]["page"];
      }
      if(isset($src[$elt_name][0]["attrs"]["content"]))
      { if(!isset($dest[$elt_name][0]["attrs"])) $dest[$elt_name][0]["attrs"] = array();
        $dest[$elt_name][0]["attrs"]["content"] = $src[$elt_name][0]["attrs"]["content"];
      }
      if(isset($src[$elt_name][0]["subs"]))
      { if(!isset($dest[$elt_name][0]["subs"])) $dest[$elt_name][0]["subs"] = array();
        foreach($src[$elt_name][0]["subs"] as $sub_elt_name => $sub)
        { $this->r_load_layout($src[$elt_name][0]["subs"], $dest[$elt_name][0]["subs"], $sub_elt_name);
        }
      }
    }

    function get_layout()
    { $mod = $this->etat("mod");
      $controller = $this->etat("controller");
      $action = $this->etat("action");
      $content = "";
      if(isset($this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["subs"][$action][0]["attrs"]["content"]))
      { $content = $this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["subs"][$action][0]["attrs"]["content"];
      }
      else
      { if(isset($this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["attrs"]["content"]))
        { $content = $this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["attrs"]["content"];
        }
        else
        { if(isset($this->layout["layout"][0]["subs"][$mod][0]["attrs"]["content"]))
          { $content = $this->layout["layout"][0]["subs"][$mod][0]["attrs"]["content"];
          }
        }
      }
      $page = "";
      if(isset($this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["subs"][$action][0]["attrs"]["page"]))
      { $page = $this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["subs"][$action][0]["attrs"]["page"];
      }
      else
      { if(isset($this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["attrs"]["page"]))
        { $page = $this->layout["layout"][0]["subs"][$mod][0]["subs"][$controller][0]["attrs"]["page"];
        }
        else
        { if(isset($this->layout["layout"][0]["subs"][$mod][0]["attrs"]["page"]))
          { $page = $this->layout["layout"][0]["subs"][$mod][0]["attrs"]["page"];
          }
        }
      }
      return array
      ( "page" => $page,
        "content" => $content
      );
    }

    function render_layout($layout = null)
    { if(!isset($layout)) $layout = $this->init_layout();
      if(file_exists($this->path("out").$this->path("current_out")."functions.php"))
      { require $this->path("out").$this->path("current_out")."functions.php";
      }
      if($this->path("current_out") != $this->path("dist_out") && file_exists($this->path("out").$this->path("dist_out")."functions.php"))
      { require $this->path("out").$this->path("dist_out")."functions.php";
      }
      if($layout["page"])
      { if($this->out_file_exists($layout["page"])) require $this->out_file($layout["page"]);
      }
      elseif($layout["content"])
      { if($this->out_file_exists($layout["content"])) require $this->out_file($layout["content"]);
      }
    }

  }

?>